// A mathematical game
// Copyright (C) 2004-2005 by Christian von Schultz <schultz@linux.nu>

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#ifndef FINALSCREEN_H
#define FINALSCREEN_H

#include <wx/object.h>
#include <wx/wxexpr.h>
#include <wx/panel.h>

#include <config.h>
#include "../checksetup.h"

#include "../exceptions.h"
#include "../htmlpanel.h"
#include "../windowcontents.h"

class Final: public WindowContents
{
public:
  Final() throw(): m_panel(NULL), m_button_clicked(NULL) {}
  ~Final() throw();

  virtual void Init(const wxExpr *expr,
		    wxPanel *panel) throw(Exception);

  virtual void Destroy() throw();

  virtual wxExpr* cHibernate() throw(Exception);

private:
  HtmlPanel *m_panel;
  Function *m_button_clicked;
};

#endif // FINALSCREEN_H

// 
// Local Variables:
// mode: c++
// End:
